- [HTTP request](https://developers.google.com/workspace/gmail/api/reference/rest/v1/users.messages/insert#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/workspace/gmail/api/reference/rest/v1/users.messages/insert#body.PATH_PARAMETERS)
- [Query parameters](https://developers.google.com/workspace/gmail/api/reference/rest/v1/users.messages/insert#body.QUERY_PARAMETERS)
- [Request body](https://developers.google.com/workspace/gmail/api/reference/rest/v1/users.messages/insert#body.request_body)
- [Response body](https://developers.google.com/workspace/gmail/api/reference/rest/v1/users.messages/insert#body.response_body)
- [Authorization scopes](https://developers.google.com/workspace/gmail/api/reference/rest/v1/users.messages/insert#body.aspect)
- [Try it!](https://developers.google.com/workspace/gmail/api/reference/rest/v1/users.messages/insert#try-it)

Directly inserts a message into only this user's mailbox similar to `IMAP APPEND`, bypassing most scanning and classification. Does not send a message. For more information, see [Create and send email messages](https://developers.google.com/workspace/gmail/api/guides/sending).

### HTTP request

- Upload URI, for media upload requests:  
  `POST https://gmail.googleapis.com/upload/gmail/v1/users/{userId}/messages`
- Metadata URI, for metadata-only requests:  
  `POST https://gmail.googleapis.com/gmail/v1/users/{userId}/messages`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `userId` | `string` The user's email address. The special value `me` can be used to indicate the authenticated user. |

### Query parameters

| Parameters ||
|---|---|
| `internalDateSource` | ``enum (`https://developers.google.com/workspace/gmail/api/reference/rest/v1/InternalDateSource`)`` Source for Gmail's internal date of the message. |
| `deleted` | `boolean` Mark the email as permanently deleted (not TRASH) and only visible in [Google Vault](http://support.google.com/vault/) to a Vault administrator. Only used for Google Workspace accounts. |

### Request body

The request body contains an instance of `https://developers.google.com/workspace/gmail/api/reference/rest/v1/users.messages#Message`.

### Response body

If successful, the response body contains an instance of `https://developers.google.com/workspace/gmail/api/reference/rest/v1/users.messages#Message`.

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://mail.google.com/`
- `
  https://www.googleapis.com/auth/gmail.modify`
- `
  https://www.googleapis.com/auth/gmail.insert`

For more information, see the [Authorization guide](https://developers.google.com/workspace/guides/configure-oauth-consent).